<template>
  <div class="container">
    <!-- Flex container for aligning title and button -->
    <div class="d-flex justify-content-between align-items-center mb-4">
      <h1>Workers in {{ factoryName }}</h1>
      <!-- Dugme za dodavanje novog radnika, vidljivo samo menadžerima -->
      <button v-if="isManager" class="custom-btn btn-6" @click="goToAddWorker">Add Worker</button>
    </div>

    <table class="table" v-if="workers.length > 0">
      <thead>
        <tr>
          <th scope="col">Username</th>
          <th scope="col">First Name</th>
          <th scope="col">Last Name</th>
          <th scope="col">Date of Birth</th>
          <th scope="col">Role</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="worker in workers" :key="worker.username">
          <td>{{ worker.username }}</td>
          <td>{{ worker.firstName }}</td>
          <td>{{ worker.lastName }}</td>
          <td>{{ worker.dateOfBirth }}</td>
          <td>{{ worker.role }}</td>
        </tr>
      </tbody>
    </table>

    <!-- Prikaz poruke ako nema radnika -->
    <p v-else>No workers available for this factory.</p>
  </div>
</template>


<script>
import axios from 'axios';

export default {
  data() {
    return {
      workers: [],
      factoryName: '',
      factoryId: ''
    };
  },
  mounted() {
    this.factoryId = this.$route.params.factoryId;
    this.fetchFactoryDetails();
    this.fetchWorkers();
  },
  computed: {
    isManager() {
      const user = JSON.parse(localStorage.getItem('fulluser'));
      return user && user.role === 'Menadzer';
    }
  },
  methods: {
    fetchFactoryDetails() {
      axios.get(`http://localhost:3000/factories/${this.factoryId}`)
        .then(response => {
          this.factoryName = response.data.name.name;
          console.log('Factory name (from factories.json):', this.factoryName);  // Proverite naziv fabrike
        })
        .catch(error => {
          console.error("Error fetching factory details", error);
        });
    },
    fetchWorkers() {
      axios.get('http://localhost:3000/users?role=Radnik')
        .then(response => {
          console.log('Full response from API:', response.data);
          
          // Ako API vraća ugnježdene podatke, koristite map da izvučete korisničke podatke
          this.workers = response.data.map(workerWrapper => workerWrapper.username);
          
          // Nakon što izvučemo prave podatke, možemo ih normalno filtrirati
          this.workers = this.workers.filter(worker => 
            worker.chocolateFactory && 
            worker.chocolateFactory.trim().toLowerCase() === this.factoryName.trim().toLowerCase()
          );
          
          console.log('Filtered workers:', this.workers);
          
          if (this.workers.length === 0) {
            console.log('No workers found for this factory');
          }
        })
        .catch(error => {
          console.error("Error fetching workers", error);
        });
    },
    goToAddWorker() {
      // Preusmeravanje korisnika na stranicu za registraciju
      this.$router.push({
        name: 'Register'
      });
    }
  }
};
</script>

<style scoped>
.custom-btn {
  padding: 10px 20px;
  font-size: 16px;
  border: none;
  border-radius: 5px;
  cursor: pointer;
  background-color: #ff6600; /* Svetlija narandžasta boja */
  color: white;
}

.custom-btn:hover {
  background-color: #ff3300; /* Tamnija narandžasta boja */
}
</style>

